## librnd 4.3.2

=== Makefile ===
all: FORCE
	cd src && $(MAKE) ../src_3rd/puplug/util/puplug
	cd src && $(MAKE)
	cd util && $(MAKE)
#	cd doc && $(MAKE)

test: FORCE
	cd tests && $(MAKE) test

clean: FORCE
	cd src && $(MAKE) clean
	cd util && $(MAKE) clean
#	cd doc && $(MAKE) clean
	cd tests && $(MAKE) clean
	cd src_3rd/sphash && $(MAKE) clean
	cd src_3rd/genht && $(MAKE) clean
	cd src_3rd/puplug && $(MAKE) clean
	cd src_3rd/libminuid && $(MAKE) clean ; true
	cd src_3rd/libuundo && $(MAKE) clean ; true

# Note: have to distclean utils (and tests) before src because of hidlib deps
distclean: FORCE
	$(MAKE) clean ; true
#	cd doc && $(MAKE) distclean
	cd tests && $(MAKE) distclean
	cd src && $(MAKE) distclean
	cd src_3rd/genlist && $(MAKE) clean ; true
	cd src_3rd/genregex && $(MAKE) clean ; true
	cd src_3rd/genvector && $(MAKE) clean ; true
	cd src_3rd/liblihata && $(MAKE) clean ; true
	cd src_3rd/liblihata/genht && $(MAKE) clean ; true
	cd src_3rd/qparse && $(MAKE) clean ; true
	cd src_3rd/libporty_net && $(MAKE) distclean ; true
	cd scconfig && $(MAKE) distclean ; true


install: FORCE
	cd src && $(MAKE) install
	cd util && $(MAKE) install
	cd doc && $(MAKE) install

linstall: FORCE
	cd src && $(MAKE) linstall
	cd util && $(MAKE) linstall
	cd doc && $(MAKE) linstall

uninstall: FORCE
	cd src && $(MAKE) uninstall
	cd util && $(MAKE) uninstall
	cd doc && $(MAKE) uninstall

include Makefile.conf

FORCE:

=== src_3rd/genht/Makefile ===
# use -DGENHT_WANT_INLINE to turn half of the API into static inline functions
PREFIX=/usr
INCDIR=$(install_root)$(DESTDIR)$(PREFIX)/include/genht
LIBDIR=$(install_root)$(DESTDIR)$(PREFIX)/lib

HOSTCC = $(CC)

VER_MAJOR=1
VER_MINOR=1
VER_PATCH=3
VER=$(VER_MAJOR).$(VER_MINOR).$(VER_PATCH)

CFLAGS=-g $(GENHT_CFLAGS)
LDFLAGS=$(GENHT_LDFLAGS)

BIN=mainsi
OBJS=htss.o htsp.o htsi.o htip.o htpp.o htpi.o hash.o siphash24.o
LIBSO0=libgenht.so
LIBSO=libgenht.so.$(VER)
LIBSO1=libgenht.so.$(VER_MAJOR)
LIBA=libgenht.a

all: version.h $(BIN) $(OBJS) $(LIBA) $(LIBSO)

clean:
	-rm $(BIN) $(OBJS) $(LIBA) $(LIBSO) genht_std.so genht_std.a version.h ver_edit mainsi.o mainsi.out

.SUFFIXES:
.SUFFIXES: .o .c

.c.o:
	$(CC) -o $@ -c -fPIC $< $(CFLAGS)

mainsi: mainsi.o htsi.o
	$(CC) -o $@ mainsi.o htsi.o $(LDFLAGS)

$(LIBSO): $(OBJS)
	$(CC) $(LDFLAGS) -shared -dynamic -rdynamic -o $@ $(OBJS)

$(LIBA): $(OBJS)
	ar rvu $@ $(OBJS)
	-ar s $@
	-ranlib $@

# for compatibility
genht_std.so: $(LIBSO)
	ln -s $(LIBSO) genht_std.so

# for compatibility
genht_std.a: $(LIBA)
	ln -s $(LIBA) genht_std.a

version.h: version.h.in ver_edit
	./ver_edit $(VER_MAJOR) $(VER_MINOR) $(VER_PATCH) < version.h.in > version.h

ver_edit: ver_edit.c
	$(HOSTCC) -o $@ $(CFLAGS) ver_edit.c

install_:
	mkdir -p $(INCDIR) $(LIBDIR)
	$(CP) `pwd`/hash.h $(INCDIR)/hash.h
	$(CP) `pwd`/siphash24.h $(INCDIR)/siphash24.h
	$(CP) `pwd`/ht.h $(INCDIR)/ht.h
	$(CP) `pwd`/ht.c $(INCDIR)/ht.c
	$(CP) `pwd`/version.h $(INCDIR)/version.h
	$(CP) `pwd`/ht_inlines.h $(INCDIR)/ht_inlines.h
	$(CP) `pwd`/ht_utils.h $(INCDIR)/ht_utils.h
	$(CP) `pwd`/htip.h $(INCDIR)/htip.h
	$(CP) `pwd`/htpi.h $(INCDIR)/htpi.h
	$(CP) `pwd`/htsi.h $(INCDIR)/htsi.h
	$(CP) `pwd`/htsp.h $(INCDIR)/htsp.h
	$(CP) `pwd`/htss.h $(INCDIR)/htss.h
	$(CP) `pwd`/htpp.h $(INCDIR)/htpp.h
	$(CP) `pwd`/$(LIBSO) $(LIBDIR)/$(LIBSO)
	$(CP) `pwd`/$(LIBA) $(LIBDIR)/$(LIBA)

uninstall:
	rm -rf $(INCDIR)
	rm $(LIBDIR)/$(LIBSO) $(LIBDIR)/$(LIBA) $(LIBDIR)/$(LIBSO1) $(LIBDIR)/$(LIBSO0)

install:
	$(MAKE) install_ CP="cp"
	-@rm $(LIBDIR)/$(LIBSO1) 2>/dev/null
	ln -s $(LIBSO) $(LIBDIR)/$(LIBSO1)
	-ln -s $(LIBSO) $(LIBDIR)/$(LIBSO0)

linstall:
	$(MAKE) install_ CP="ln -s"
	-@rm $(LIBDIR)/$(LIBSO1) 2>/dev/null
	ln -s $(LIBSO) $(LIBDIR)/$(LIBSO1)
	-ln -s $(LIBSO) $(LIBDIR)/$(LIBSO0)

test: mainsi
	@./mainsi > mainsi.out
	@diff mainsi.ref mainsi.out
	@echo "*** QC pass ***"

=== src_3rd/genprints/Makefile ===
CFLAGS = -Wall -g -std=c89 -ansi -pedantic

example: example.c genprints.h

=== src_3rd/libulzw/Makefile ===
# where to install:
PREFIX=/usr/local
INCDIR=$(DESTDIR)$(inst_root)$(PREFIX)/include/libulzw
LIBDIR=$(DESTDIR)$(inst_root)$(PREFIX)/lib

CFLAGS_CFG=-O3
#CFLAGS_CFG=-Wall -g
CFLAGS = $(CFLAGS_CFG) -I.. $(CFLAGS_LIBULZW)

OBJSA=libulzw_comp.o libulzw_decomp.o
LIBA=libulzw.a
PWD=`pwd`

all: $(LIBA)

libulzw_comp.o: libulzw_comp.c
	$(CC) $(CFLAGS) -c libulzw_comp.c -o libulzw_comp.o

libulzw_decomp.o: libulzw_decomp.c
	$(CC) $(CFLAGS) -c libulzw_decomp.c -o libulzw_decomp.o

$(LIBA): $(OBJSA)
	touch $(LIBA)
	rm $(LIBA)
	ar ru $(LIBA) $(OBJSA)
	-ar s $(LIBA)
	-ranlib $(LIBA)

install_: $(LIBA)
	mkdir -p $(LIBDIR) $(INCDIR)
	$(CP) $(PWD)/libulzw.h            $(INCDIR)/libulzw.h
	$(CP) $(PWD)/$(LIBA)              $(LIBDIR)/$(LIBA)

uninstall:
	-rm $(INCDIR)/*_api.h $(INCDIR)/*_impl.h $(INCDIR)/libulzw.h $(LIBDIR)/$(LIBA)
	-rmdir $(INCDIR)

install:
	make install_ CP="cp"

linstall:
	make install_ CP="ln -s"

clean:
	-rm $(LIBA) $(OBJSA)

=== src/librnd/plugins/hid_gtk2_gl/Makefile ===
all:
	cd ../../.. && $(MAKE) mod_hid_gtk2_gl

clean:
	rm *.o *.so 2>/dev/null ; true

=== src/librnd/plugins/lib_gtk4_common/Makefile ===
all:
	cd ../../.. && $(MAKE) mod_lib_gtk4_common

clean:
	rm *.o *.so 2>/dev/null ; true

=== src/librnd/plugins/loghid/Makefile ===
all:
	cd ../../.. && $(MAKE) mod_loghid

clean:
	rm *.o *.so 2>/dev/null ; true

=== debian/changelog ===
librnd (4.3.2-2) unstable; urgency=medium

  * add -std=c17 to innoculate against gcc 15 changes, closes: #1097265

 -- Bdale Garbee <bdale@gag.com>  Sat, 06 Sep 2025 11:36:29 -0600

librnd (4.3.2-1) unstable; urgency=medium

  * new upstream version

 -- Bdale Garbee <bdale@gag.com>  Wed, 12 Mar 2025 20:39:10 -0600

=== debian/rules ===
#!/usr/bin/make -f

# treating implicit declarations as errors breaks scconfig, so let's not do
# that until/unless upstream fixes things
export DEB_CFLAGS_MAINT_STRIP=-Werror=implicit-function-declaration

DH_VERBOSE = 1
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

# Workaround on exotic archs, probably any 32 bit arch with 64 bit kernel
# see bug #1019729
CFLAGS += -D_LARGE_FILE_SOURCE=1 -D_FILE_OFFSET_BITS=64

# resolve FTBFS with gcc 15 until upstream comes up with a better solution
CFLAGS += -std=c17

%:
ifeq (mipsel,$(findstring mipsel,$(DEB_HOST_ARCH)))
	dh $@ --no-parallel
else ifeq (mips64el,$(findstring mips64el,$(DEB_HOST_ARCH)))
	dh $@ --no-parallel
else
	dh $@
endif

override_dh_auto_clean:
	# only try to run dh_auto_clean if configure has been run
	test -f Makefile.conf && dh_auto_clean || true

override_dh_auto_configure:
	./configure \
		--LDFLAGS='$(LDFLAGS)' \
		--CFLAGS='$(CFLAGS) $(CPPFLAGS)' \
		\
		--symbols \
		--prefix=/usr \
		\
		--all=disable \
		--buildin-script \
		--buildin-diag_rnd \
		--buildin-lib_gensexpr \
		--buildin-hid_batch \
		--buildin-lib_portynet \
		--buildin-lib_exp_text \
		--buildin-import_pixmap_pnm \
		--plugin-lib_hid_gl \
		--plugin-lib_wget \
		--plugin-lib_gtk4_common \
		--plugin-lib_hid_common \
		--plugin-import_pixmap_gd \
		--plugin-hid_lesstif \
		--plugin-hid_gtk4_gl \
		--plugin-irc \
		--plugin-lib_exp_pixmap \

## librnd 4.4.0

=== tests/Makefile ===
test:
	cd rnd_printf && $(MAKE) all && $(MAKE) test
	cd remote && $(MAKE) all && $(MAKE) test
# This uses make instead of $(MAKE) on purpose as a "portable" -j1 to work around GNU make
	cd librnd && make all && make test
	cd conf && $(MAKE) all && make test
	cd base64 && $(MAKE) all && make test
	@echo " "
	@echo "+-------------------------------------------------+"
	@echo "+  All tests passed, librnd is safe to install.   +"
	@echo "+-------------------------------------------------+"

clean:
	cd rnd_printf && $(MAKE) clean
	cd remote && $(MAKE) clean
	cd librnd && $(MAKE) clean
	cd conf && $(MAKE) clean
	cd base64 && $(MAKE) clean

distclean:
	cd librnd && $(MAKE) distclean

=== util/Makefile ===
# plain old hand crafted Makefile
ROOT=..

all:

include $(ROOT)/Makefile.conf

DEVHLP=$(LIBDIR)/devhelpers

clean:

distclean:

install_all:
	$(SCCBOX) mkdir -p  "$(DEVHLP)"
	$(SCCBOX) $(HOW) devhelpers/awk_on_formats.sh "$(DEVHLP)/awk_on_formats.sh"
	$(SCCBOX) $(HOW) devhelpers/list_dialogs.sh "$(DEVHLP)/list_dialogs.sh"
	$(SCCBOX) $(HOW) devhelpers/font2c.sh "$(DEVHLP)/font2c.sh"
	$(SCCBOX) $(HOW) build_ps.sh "$(LIBDIR)/build_ps.sh"
	$(SCCBOX) $(HOW) keylist.sh "$(LIBDIR)/keylist.sh"
	$(SCCBOX) $(HOW) menu2svg.sh "$(LIBDIR)/menu2svg.sh"
	$(SCCBOX) $(HOW) action_compiler.sh "$(LIBDIR)/action_compiler.sh"
	$(SCCBOX) $(HOW) dump_actions_to_html.sh  "$(LIBDIR)/dump_actions_to_html.sh"
	$(SCCBOX) $(HOW) gen_formats.sh  "$(LIBDIR)/gen_formats.sh"

install:
	$(MAKE) install_all HOW="install -f"

linstall:
	$(MAKE) install_all HOW="linstall -f"

uninstall:
	$(MAKE) install_all HOW="uninstall"

=== doc/developer/Makefile ===
ROOT=../..
DEVDIR=$(DOCDIR)/developer

all:

install_all:
	$(SCCBOX) mkdir -p $(DEVDIR)/hid_remote
	$(SCCBOX) $(HOW) hid_remote/*.html hid_remote/*.svg $(DEVDIR)/hid_remote/
	$(SCCBOX) $(HOWF) packaging/librnd_packages.sh $(DATADIR)/librnd_packages.sh

install:
	$(MAKE) install_all HOW="install -f -d" HOWF="install -f"

linstall:
	$(MAKE) install_all HOW="install -f -l -d" HOWF="install -f -l"

uninstall:
	$(MAKE) install_all HOW="install -u" HOWF="install -u"

clean:

distclean:


include $(ROOT)/Makefile.conf

=== src_3rd/genfip/Makefile ===
PREFIX=/usr/local
INCDIR=$(install_root)$(DESTDIR)$(PREFIX)/include/genfip
CP=cp
MKDIR=mkdir -p
LN=ln -sf

all:

install_:
	$(MKDIR) $(INCDIR)
	$(CP) `pwd`/big.h         $(INCDIR)/big.h
	$(CP) `pwd`/config.h      $(INCDIR)/config.h
	$(CP) `pwd`/fip11.h       $(INCDIR)/fip11.h
	$(CP) `pwd`/fip_implc.h   $(INCDIR)/fip_implc.h
	$(CP) `pwd`/fip_implh.h   $(INCDIR)/fip_implh.h
	$(CP) `pwd`/fip_mpi.h     $(INCDIR)/fip_mpi.h
	$(CP) `pwd`/fip_undef.h   $(INCDIR)/fip_undef.h
	$(CP) `pwd`/rational.h    $(INCDIR)/rational.h

uninstall:
	$(RM)   $(INCDIR)/big.h
	$(RM)   $(INCDIR)/config.h
	$(RM)   $(INCDIR)/fip11.h
	$(RM)   $(INCDIR)/fip_implc.h
	$(RM)   $(INCDIR)/fip_implh.h
	$(RM)   $(INCDIR)/fip_mpi.h
	$(RM)   $(INCDIR)/fip_undef.h
	$(RM)   $(INCDIR)/rational.h

install:
	make install_ CP="$(CP)" MKDIR="$(MKDIR)"

linstall:
	make install_ CP="$(LN)" MKDIR="$(MKDIR)"

=== src_3rd/genregex/Makefile ===
#CFLAGS = -Wall -ansi -pedantic -g
CFLAGS = -g $(GENREGEX_CFLAGS)
LDFLAGS = $(GENREGEX_LDFLAGS)

PREFIX=/usr
INCDIR=$(install_root)$(DESTDIR)$(PREFIX)/include/genregex
LIBDIR=$(install_root)$(DESTDIR)$(PREFIX)/lib


OBJS = tester.o regex.o  regex_se.o regex_sei.o regex_be.o regex_bei.o \
       regex_st.o regex_sti.o regex_bt.o regex_bti.o

LIBA = libgenregex.a

all: tester $(LIBA)

tester: $(OBJS)

tester.o: tester.c regex_se.h regex_be.h regex_st.h regex_bt.h regex_templ.h regex.h tester_main.c

regex.o: regex.c regex.h

regex_se.o: regex_se.c regex_se.h   regex_templ.c regex_templ.h regex.h

regex_sei.o: regex_sei.c regex_sei.h   regex_templ.c regex_templ.h regex.h

regex_be.o: regex_be.c regex_be.h   regex_templ.c regex_templ.h regex.h

regex_bei.o: regex_bei.c regex_bei.h   regex_templ.c regex_templ.h regex.h

regex_st.o: regex_st.c regex_st.h   regex_templ.c regex_templ.h regex.h

regex_sti.o: regex_sti.c regex_sti.h   regex_templ.c regex_templ.h regex.h

regex_bt.o: regex_bt.c regex_bt.h   regex_templ.c regex_templ.h regex.h

regex_bti.o: regex_bti.c regex_bti.h   regex_templ.c regex_templ.h regex.h

$(LIBA): $(OBJS)
	-rm $(LIBA)
	ar r $(LIBA) $(OBJS)
	-ar s $(LIBA)
	-ranlib $(LIBA)

test:
	cd ../regression; make all

clean:
	rm $(OBJS) $(LIBA) tester 2>/dev/null ; true

install_:
	mkdir -p $(INCDIR) $(LIBDIR)
	$(CP) `pwd`/regex.h          $(INCDIR)/regex.h
	$(CP) `pwd`/regex_be.h       $(INCDIR)/regex_be.h
	$(CP) `pwd`/regex_bei.h      $(INCDIR)/regex_bei.h
	$(CP) `pwd`/regex_bt.h       $(INCDIR)/regex_bt.h
	$(CP) `pwd`/regex_bti.h      $(INCDIR)/regex_bti.h
	$(CP) `pwd`/regex_se.h       $(INCDIR)/regex_se.h
	$(CP) `pwd`/regex_sei.h      $(INCDIR)/regex_sei.h
	$(CP) `pwd`/regex_st.h       $(INCDIR)/regex_st.h
	$(CP) `pwd`/regex_sti.h      $(INCDIR)/regex_sti.h
	$(CP) `pwd`/regex_templ.h    $(INCDIR)/regex_templ.h
	$(CP) `pwd`/libgenregex.a    $(LIBDIR)/libgenregex.a

uninstall:
	rm $(INCDIR)/regex.h
	rm $(INCDIR)/regex_be.h
	rm $(INCDIR)/regex_bei.h
	rm $(INCDIR)/regex_bt.h
	rm $(INCDIR)/regex_bti.h
	rm $(INCDIR)/regex_se.h
	rm $(INCDIR)/regex_sei.h
	rm $(INCDIR)/regex_st.h
	rm $(INCDIR)/regex_sti.h
	rm $(INCDIR)/regex_templ.h
	rm $(LIBDIR)/libgenregex.a

install:
	make install_ CP="cp"

linstall:
	make install_ CP="ln -s"

=== src_3rd/liblihata/Makefile ===
ROOT=..
CFLAGS = -Wall -g -I.. $(LIHATA_CFLAGS)
OBJS_PARSER = parser.o lihata.o
OBJS_DOM = hash_str.o dom.o dom_hash.o dom_list.o dom_table.o
OBJS_TREE = tree.o tree_list.o tree_hash.o tree_table.o tree_path.o tree_symlink.o
OBJS = test_parser.o test_dom.o test_tree.o  $(OBJS_PARSER) $(OBJS_DOM) $(OBJS_TREE)
TESTERS = test_parser test_dom test_tree
LIBS = liblihata.a
include $(ROOT)/Makefile.conf
LDLIBS=$(LIBGENHT)


all: $(TESTERS) $(LIBS)

test_parser: test_parser.o $(OBJS_PARSER) $(LIBGENHT_DEP)
	$(CC) $(LDFLAGS) test_parser.o $(OBJS_PARSER) $(LDLIBS) -o $@

test_dom: test_dom.o $(OBJS_DOM) $(OBJS_PARSER) $(LIBGENHT_DEP)
	$(CC) $(LDFLAGS) test_dom.o $(OBJS_DOM) $(OBJS_PARSER) $(LDLIBS) -o $@

test_tree: test_tree.o $(OBJS_TREE) $(OBJS_DOM) $(OBJS_PARSER) $(LIBGENHT_DEP)
	$(CC) $(LDFLAGS) test_tree.o $(OBJS_TREE) $(OBJS_DOM) $(OBJS_PARSER) $(LDLIBS) -o $@

liblihata.a: $(OBJS_DOM) $(OBJS_PARSER) $(OBJS_TREE)
	ar rvu $@ $(OBJS_DOM) $(OBJS_PARSER) $(OBJS_TREE)
	-ar s $@
	-ranlib $@

lib_obj_list:
	@echo $(OBJS_DOM) $(OBJS_PARSER) $(OBJS_TREE)

../genht/htsp.o:
	$(CC) $(CFLAGS) -c ../genht/htsp.c -o ../genht/htsp.o

# dependencies

include Makefile.dep

depend:
	@echo "# Generated by \"make depend\"" > Makefile.dep
	gcc $(CFLAGS) -MM `echo $(OBJS) | sed "s/\.o/.c/g"` | sed "s/^htsp.o.*//; s%[.][.]/genht/[a-zA-Z0-9_]*[.][hoc]%%g" >> Makefile.dep

ns: liblihata.a
	@echo Namespace pollution in objects:
	@nm liblihata.a | awk '/ [ABCDGNRSTVW] / { if (($$(NF) ~ "^lht_") || ($$(NF) ~ "^hts._")) next; print $$0}'

test:
	cd regression && make

clean:
	-rm $(OBJS) $(TESTERS) $(LIBS) 2>/dev/null

dist-clean: clean

install_:
	mkdir -p $(LIBDIR) $(INCDIR)
	$(CP) $(PWD)/liblihata.a $(LIBDIR)/liblihata.a
	$(CP) $(PWD)/dom.h $(INCDIR)/dom.h
	$(CP) $(PWD)/hash_str.h $(INCDIR)/hash_str.h
	$(CP) $(PWD)/lihata.h $(INCDIR)/lihata.h
	$(CP) $(PWD)/parser.h $(INCDIR)/parser.h
	$(CP) $(PWD)/tree.h $(INCDIR)/tree.h

uninstall:
	rm $(LIBDIR)/liblihata.a
	rm -rf $(INCDIR)

install:
	make install_ CP="cp" PWD=`pwd`

linstall:
	make install_ CP="ln -sf" PWD=`pwd`

include $(ROOT)/Makefile.common

=== src_3rd/libporty_net/Makefile ===
ROOT=../..

#CFLAGS = -Wall -O3

libportytcp4.o: libportytcp4.c libportytcp4.h

libportytcp4.c libportytcp4.h: concat.sh
	./concat.sh

include ../../Makefile.conf

clean:

distclean:
	$(SCCBOX) rm -f -q os_includes.h pnet_config.h phost_types.h

=== src_3rd/libualloc/Makefile ===
# where to install:
PREFIX=/usr/local
INCDIR=$(DESTDIR)$(inst_root)$(PREFIX)/include/libualloc
LIBDIR=$(DESTDIR)$(inst_root)$(PREFIX)/lib

CFLAGS = -Wall -g -I..

OBJSA=slab_impl.o slabap_impl.o stackd_impl.o stackdnp_impl.o stacks_impl.o mcache_impl.o acache_impl.o buddy_impl.o buddy_debug.o libualloc.o
LIBA=libualloc.a
PWD=`pwd`

all: $(LIBA)

slab_impl.o: slab_impl.c
	$(CC) $(CFLAGS) -c slab_impl.c -o slab_impl.o

slabap_impl.o: slabap_impl.c
	$(CC) $(CFLAGS) -c slabap_impl.c -o slabap_impl.o

stackd_impl.o: stackd_impl.c
	$(CC) $(CFLAGS) -c stackd_impl.c -o stackd_impl.o

stackdnp_impl.o: stackdnp_impl.c
	$(CC) $(CFLAGS) -c stackdnp_impl.c -o stackdnp_impl.o

stacks_impl.o: stacks_impl.c
	$(CC) $(CFLAGS) -c stacks_impl.c -o stacks_impl.o

mcache_impl.o: mcache_impl.c
	$(CC) $(CFLAGS) -c mcache_impl.c -o mcache_impl.o

acache_impl.o: acache_impl.c
	$(CC) $(CFLAGS) -c acache_impl.c -o acache_impl.o

buddy_impl.o: buddy_impl.c
	$(CC) $(CFLAGS) -c buddy_impl.c -o buddy_impl.o

buddy_debug.o: buddy_debug.c
	$(CC) $(CFLAGS) -c buddy_debug.c -o buddy_debug.o

$(LIBA): $(OBJSA) libualloc.o
	touch $(LIBA)
	rm $(LIBA)
	ar ru $(LIBA) $(OBJSA) libualloc.o

install_: $(LIBA)
	mkdir -p $(LIBDIR) $(INCDIR)
	$(CP) $(PWD)/libualloc.h            $(INCDIR)/libualloc.h
	$(CP) $(PWD)/libualloc_impl.h       $(INCDIR)/libualloc_impl.h
	$(CP) $(PWD)/slab_api.h             $(INCDIR)/slab_api.h
	$(CP) $(PWD)/slab_impl.h            $(INCDIR)/slab_impl.h
	$(CP) $(PWD)/slabap_api.h           $(INCDIR)/slabap_api.h
	$(CP) $(PWD)/slabap_impl.h          $(INCDIR)/slabap_impl.h
	$(CP) $(PWD)/stackd_api.h           $(INCDIR)/stackd_api.h
	$(CP) $(PWD)/stackd_impl.h          $(INCDIR)/stackd_impl.h
	$(CP) $(PWD)/stacks_api.h           $(INCDIR)/stacks_api.h
	$(CP) $(PWD)/stacks_impl.h          $(INCDIR)/stacks_impl.h
	$(CP) $(PWD)/mcache_api.h           $(INCDIR)/mcache_api.h
	$(CP) $(PWD)/mcache_impl.h          $(INCDIR)/mcache_impl.h
	$(CP) $(PWD)/acache_api.h           $(INCDIR)/acache_api.h
	$(CP) $(PWD)/acache_impl.h          $(INCDIR)/acache_impl.h
	$(CP) $(PWD)/buddy_api.h            $(INCDIR)/buddy_api.h
	$(CP) $(PWD)/buddy_impl.h           $(INCDIR)/buddy_impl.h
	$(CP) $(PWD)/buddy_debug.h          $(INCDIR)/buddy_debug.h
	$(CP) $(PWD)/$(LIBA)                $(LIBDIR)/$(LIBA)

uninstall:
	-rm $(INCDIR)/*_api.h $(INCDIR)/*_impl.h $(INCDIR)/libualloc.h $(LIBDIR)/$(LIBA)
	-rmdir $(INCDIR)

install:
	make install_ CP="cp"

linstall:
	make install_ CP="ln -s"

clean:
	-rm $(LIBA) $(OBJSA)

=== src_3rd/libuirc/Makefile ===
CFLAGS = -Wall -g -I.. -DLIBUIRC_TRACE
LDFLAGS = -lm
LIBS = ../libporty_net/libportytcp4.o ../genvector/gds_char.o ../../src/librnd/core/compat_misc.o

main: main.o libuirc.o $(LIBS)

main.o: main.c

libuirc.o: libuirc.c libuirc.h

=== tests/base64/Makefile ===
ROOT=../..
LIBRND=$(ROOT)/src/librnd/core
include $(ROOT)/Makefile.conf

CFLAGS = -Wall -g -I$(ROOT)/src $(PCB_RND_C89FLAGS)

all: main

test: main
	@./main && echo "*** QC PASS ***"

main: main.o $(LIBRND)/base64.o
	$(CC) $(LDFLAGS) -o main   main.o $(LIBRND)/base64.o

main.o: main.c
	$(CC) -o main.o -c $(CFLAGS) main.c

clean:
	-rm main main.o

=== tests/conf/Makefile ===
ROOT=../..
include $(ROOT)/Makefile.conf
include $(ROOT)/src/librnd/core/librnd.mak

CFLAGS = $(PCB_RND_C89FLAGS) -I$(ROOT)/src -I$(ROOT)/src_3rd $(CFLAGS_LIBRND_FUNGW) $(CFLAGS_LIBRND)
LDLIBS = -lm $(LDFLAGS_LIBRND_FUNGW) $(LDFLAGS_LIBRND)

HELPER_OBJS=conf_core.o
LIBRND_OBJS= \
 $(ROOT)/src/librnd/plugins/diag_rnd/diag_rnd.o \
 $(ROOT)/src/librnd-hid.a $(ROOT)/src/librnd-core.a $(ROOT)/src/librnd-3rd.a

DEPH = \
	$(ROOT)/src/librnd/core/conf.h \
	$(ROOT)/src/librnd/core/conf_hid.h \
	$(ROOT)/src/librnd/core/compat_misc.h \
	conf_core.h diag_conf.h

OBJS = conftest.o help.o

all: conftest

conftest: $(OBJS) $(HELPER_OBJS) $(LIBRND_OBJS)
	$(CC) $(LDFLAGS) $(OBJS) $(HELPER_OBJS) $(LIBRND_OBJS) $(LDLIBS) -o conftest

conftest.o: conftest.c $(DEPH)
	$(CC) $(CFLAGS) -c conftest.c -o conftest.o

help.o: help.c

$(ROOT)/src/librnd/plugins/diag_rnd/diag_rnd.o:  $(ROOT)/src/librnd/plugins/diag_rnd/diag_rnd.c

$(LIBRND_OBJS):
	cd ../../src && make

test:
	cd tests && $(MAKE) all

clean:
	-$(SCCBOX) rm -f conftest tests/*.out $(OBJS) $(HELPER_OBJS)

=== tests/librnd/Makefile ===
TRUNK = ../..
LIBRND_ROOT=include/$(HL_LIBDIR)/..
SCCBX=$(TRUNK)/scconfig/sccbox

include $(TRUNK)/Makefile.conf
include $(TRUNK)/src/librnd/core/librnd.mak


CFLAGS =  -I$(LIBRND_ROOT)/include/librnd4 -I$(LIBRND_ROOT)/include/librnd4/librnd/src_3rd $(PCB_RND_C89FLAGS) $(CFLAGS_LIBRND_STATIC)
LDFLAGS = $(LIBRND_RDYNAMIC) $(LDFLAGS_LIBRND_STATIC)
LIBRND_A = include/$(HL_LIBDIR)/librnd-font2.a include/$(HL_LIBDIR)/librnd-poly.a include/$(HL_LIBDIR)/librnd-hid.a include/$(HL_LIBDIR)/librnd-core.a include/$(HL_LIBDIR)/librnd-3rd.a

all: librnd_test librnd_includes

test: librnd_test librnd_includes
	./librnd_test --gui batch
	./librnd_includes

librnd_objs: $(LIBRND_A)
	$(SCCBX) mkdir -p obj obj/font2 obj/poly obj/hid obj/core obj/3rd
	$(SCCBX) rm -f obj/font2/*.o obj/poly/*.o obj/hid/*.o obj/core/*.o obj/3rd/*.o
	cd obj/hid &&  ar x ../../include/$(HL_LIBDIR)/librnd-hid.a
	cd obj/core &&  ar x ../../include/$(HL_LIBDIR)/librnd-core.a
	cd obj/font2 && ar x ../../include/$(HL_LIBDIR)/librnd-font2.a
	cd obj/poly && ar x ../../include/$(HL_LIBDIR)/librnd-poly.a
	cd obj/3rd &&  ar x ../../include/$(HL_LIBDIR)/librnd-3rd.a  


librnd_test: librnd_test.o librnd_objs
	$(CC) -o librnd_test librnd_test.o obj/hid/*.o obj/core/*.o obj/font2/*.o obj/poly/*.o obj/3rd/*.o $(LDFLAGS)


librnd_test.o: librnd_test.c includes
	$(CC) $(CFLAGS) -c -o librnd_test.o librnd_test.c

librnd_includes: librnd_includes.o librnd_objs
	$(CC) -o librnd_includes librnd_includes.o  obj/hid/*.o obj/core/*.o obj/font2/*.o obj/poly/*.o  obj/3rd/*.o $(LDFLAGS)

librnd_includes.o: librnd_includes.c includes
	$(CC) $(CFLAGS) -c -o librnd_includes.o librnd_includes.c

# $(LIBRND_A) has multiple files; "flatten" this into a single rule so that
# make -j12 won't attempt to run them parallel
$(LIBRND_A): includes

# install all binaries and includes to $$TDIR/include
includes: ../../src/Makefile
	TDIR=`pwd` && cd ../../src && $(MAKE) && $(MAKE) install HOW="install -f" DESTDIR=$$TDIR/include PREFIX=

clean:
	$(SCCBX) rm -f librnd_test librnd_test.o librnd_includes librnd_includes.o
	-TDIR=`pwd` && cd ../../src && $(MAKE) uninstall HOW="uninstall -f" DESTDIR=$$TDIR/include PREFIX=
	-rm -rf include/usr obj

distclean:
	$(SCCBX) rm -f inc_all.h

=== debian/changelog ===
librnd (4.4.0-1) unstable; urgency=medium

  * new upstream version, with gcc 15 support

 -- Bdale Garbee <bdale@gag.com>  Wed, 24 Sep 2025 22:29:36 -0300

=== debian/control ===
Source: librnd
Section: electronics
Priority: optional
Maintainer: Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
Uploaders: Bdale Garbee <bdale@gag.com>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 11), imagemagick, libgd-dev, libmotif-dev, libstroke0-dev, libgenht1-dev, libfungw-dev, libgtk-4-dev, libepoxy-dev, libglu1-mesa-dev | libglu-dev
Standards-Version: 4.5.1
Homepage: http://repo.hu/projects/librnd
Vcs-Git: https://salsa.debian.org/electronics-team/ringdove-eda/librnd.git
Vcs-Browser: https://salsa.debian.org/electronics-team/ringdove-eda/librnd

Package: librnd4t64
Provides: ${t64:Provides}
Replaces: librnd4
Breaks: librnd4 (<< ${source:Version})
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Ringdove 2D CAD library framework
 librnd is a modular framework library for 2D CAD applications. It
 provides the following built-in features:
   - hierarchic configuration files
   - flexible menu and hotkey system
   - HID API for CLI/GUI frontend
   - multi-layer rendering support
   - interactive drawing tool infrastructure
   - action infrastructure
   - polygon clipping
   - turing complete user scripting
 .
 Supported via plugins:
   - CLI/batch frontend
   - gtk4 frontend with gl hardware accelerated rendering
   - lesstif/motif frontend

Package: librnd4-dev
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, librnd4t64 (= ${binary:Version}), libgenht1-dev, libfungw-dev
Provides: librnd-dev (= ${binary:Version})
Conflicts: librnd3-dev
Replaces: librnd-dev (<< 4.0.0-1)
Breaks: librnd-dev (<< 4.0.0-1)
Description: Ringdove 2D cad library, files for development.
 Headers, templates, scripts for compiling Ringdove applications.

Package: librnd4-doc
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Documentation for librnd.
 Developer documentation for using librnd.

Package: librnd4-cloud
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, librnd4t64 (= ${binary:Version})
Description: Networking plugins for accessing remote resources.
 Support library plugin for 'cloud' footprint/symbol access plugin
 that integrates remote, web access resources like edakrill or
 gedasymbols.org.

Package: librnd4-lib-gui
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, librnd4t64 (= ${binary:Version})
Description: Support library for building the GUI.
 Provides librnd specific dialog boxes (e.g. fontsel) and top window
 GUI elements.

Package: librnd4-pixmap
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, librnd4t64 (= ${binary:Version})
Description: Import and export pixmap images.
 Low level support for png/jpeg/gif export plugins, low level import
 pixmap objects using libgd.

Package: librnd4-hid-lesstif
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, librnd4t64 (= ${binary:Version}), librnd4-lib-gui (= ${binary:Version})
Description: GUI: motif/lesstif, software render
 Lightweight GUI and software rendering using the motif (lesstif)
 toolkit.

Package: librnd4-lib-gl
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, librnd4t64 (= ${binary:Version})
Description: Support library for rendering with opengl.
 Provides plugins for driving an opengl output, rendering the drawing
 on opengl.

Package: librnd4-hid-gtk4-gl
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, librnd4t64 (= ${binary:Version}), librnd4-lib-gui (= ${binary:Version}), librnd4-lib-gl (= ${binary:Version})
Description: GUI: gtk4, opengl
 Hardware accelerated (opengl) rendering on gtk4.

=== debian/rules ===
--- 
+++ 
@@ -12,9 +12,6 @@
 # Workaround on exotic archs, probably any 32 bit arch with 64 bit kernel
 # see bug #1019729
 CFLAGS += -D_LARGE_FILE_SOURCE=1 -D_FILE_OFFSET_BITS=64
-
-# resolve FTBFS with gcc 15 until upstream comes up with a better solution
-CFLAGS += -std=c17
 
 %:
 ifeq (mipsel,$(findstring mipsel,$(DEB_HOST_ARCH)))

=== debian/watch ===
version=4
opts=dversionmangle=s/\+repack.*$// \
  http://www.repo.hu/projects/librnd/releases/librnd-(.*)\.tar\.gz
